package com.jasamedika.medifirst2000.vo;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.*;
import java.util.Date;
import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.vo.BaseMasterVO;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.vo.BaseMasterVO;
import com.jasamedika.medifirst2000.helper.Caption;

/**
 * class JenisProduk
 * 
 * @author Generator
 */
//@Entity
//@Table(name = "JenisProduk_M")
public class JenisProdukVO extends BaseMasterVO {
	@Caption(value = "Jenis Produk")
	private String jenisProduk;

	public void setJenisProduk(String jenisProduk) {
		this.jenisProduk = jenisProduk;
	}

	@Column(name = "JenisProduk", nullable = false, length = 80)
	public String getJenisProduk() {
		return this.jenisProduk;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectAccountFk")
	@Caption(value = "Object Account")
	private ChartOfAccountVO account;

	public void setAccount(ChartOfAccountVO account) {
		this.account = account;
	}

	@Column(name = "KdAccount", nullable = true)
	public ChartOfAccountVO getAccount() {
		return this.account;
	}

	@Column(name = "ObjectAccountFk", insertable = false, updatable = false)
	private Integer accountId;

	@ManyToOne
	@JoinColumn(name = "ObjectDepartemenFk")
	@NotNull(message = "Object DepartemenVO Harus Diisi")
	@Caption(value = "Object Departemen")
	private DepartemenVO departemen;

	public void setDepartemen(DepartemenVO departemen) {
		this.departemen = departemen;
	}

	@Column(name = "KdDepartemen", nullable = false, length = 1)
	public DepartemenVO getDepartemen() {
		return this.departemen;
	}

	@Column(name = "ObjectDepartemenFk", insertable = false, updatable = false)
	private Integer departemenId;

	@Caption(value = "Kode Jenis Produk")
	private String kdJenisProduk;

	public void setKdJenisProduk(String kdJenisProduk) {
		this.kdJenisProduk = kdJenisProduk;
	}

	@Column(name = "KdJenisProduk", nullable = false, length = 2)
	public String getKdJenisProduk() {
		return this.kdJenisProduk;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectJenisProdukHeadFk")
	@Caption(value = "Object Jenis ProdukVO Head")
	private JenisProdukVO jenisProdukHead;

	public void setJenisProdukHead(JenisProdukVO jenisProdukHead) {
		this.jenisProdukHead = jenisProdukHead;
	}

	@Column(name = "KdJenisProdukHead", nullable = true, length = 2)
	public JenisProdukVO getJenisProdukHead() {
		return this.jenisProdukHead;
	}

	@Column(name = "ObjectJenisProdukHeadFk", insertable = false, updatable = false)
	private Integer jenisProdukHeadId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelompokProdukFk")
	@NotNull(message = "Object Kelompok ProdukVO Harus Diisi")
	@Caption(value = "Object Kelompok Produk")
	private KelompokProdukVO kelompokProduk;

	public void setKelompokProduk(KelompokProdukVO kelompokProduk) {
		this.kelompokProduk = kelompokProduk;
	}

	@Column(name = "KdKelompokProduk", nullable = false)
	public KelompokProdukVO getKelompokProduk() {
		return this.kelompokProduk;
	}

	@Column(name = "ObjectKelompokProdukFk", insertable = false, updatable = false)
	private Integer kelompokProdukId;

	@Caption(value = "QJenis Produk")
	private short qJenisProduk;

	public void setqJenisProduk(short qJenisProduk) {
		this.qJenisProduk = qJenisProduk;
	}

	@Column(name = "QJenisProduk", nullable = false)
	public short getqJenisProduk() {
		return this.qJenisProduk;
	}

	/*//
	@OneToMany(fetch = FetchType.LAZY, cascade = CascadeType.ALL, mappedBy = "kdjenisproduk")
	private Set<DetailJenisProduk> DetailJenisProdukSet = new HashSet<DetailJenisProduk>();

	public Set<DetailJenisProduk> getDetailJenisProdukSet() {
		return DetailJenisProdukSet;
	}

	public void setDetailJenisProdukSet(Set<DetailJenisProduk> detailJenisProdukSet) {
		DetailJenisProdukSet = detailJenisProdukSet;
	}

	//
	@OneToMany(fetch=FetchType.LAZY, cascade = CascadeType.ALL, mappedBy="kdjenisprodukhead")
	private Set<JenisProduk> JenisProdukSet = new HashSet<JenisProduk>();

	public Set<JenisProduk> getJenisProdukSet() {
		return JenisProdukSet;
	}

	public void setJenisProdukSet(Set<JenisProduk> jenisProdukSet) {
		JenisProdukSet = jenisProdukSet;
	}*/
}
